"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from mollie import utils
from mollie.types import BaseModel, OptionalNullable, UNSET
from mollie.utils import FieldMetadata, PathParamMetadata, RequestMetadata
import pydantic
from typing import Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class PaymentCreateRouteAmountTypedDict(TypedDict):
    r"""The amount of the route. That amount that will be routed to the specified destination."""

    currency: str
    r"""A three-character ISO 4217 currency code."""
    value: str
    r"""A string containing an exact monetary amount in the given currency."""


class PaymentCreateRouteAmount(BaseModel):
    r"""The amount of the route. That amount that will be routed to the specified destination."""

    currency: str
    r"""A three-character ISO 4217 currency code."""

    value: str
    r"""A string containing an exact monetary amount in the given currency."""


class PaymentCreateRouteDestinationTypedDict(TypedDict):
    r"""The destination of the route."""

    type: NotRequired[str]
    r"""The type of destination. Currently only the destination type `organization` is supported.

    Possible values: `organization`
    """
    organization_id: NotRequired[str]
    r"""Required for destination type `organization`. The ID of the connected organization the funds should be routed to."""


class PaymentCreateRouteDestination(BaseModel):
    r"""The destination of the route."""

    type: Optional[str] = None
    r"""The type of destination. Currently only the destination type `organization` is supported.

    Possible values: `organization`
    """

    organization_id: Annotated[
        Optional[str], pydantic.Field(alias="organizationId")
    ] = None
    r"""Required for destination type `organization`. The ID of the connected organization the funds should be routed to."""


class PaymentCreateRouteRequestBodyTypedDict(TypedDict):
    amount: NotRequired[PaymentCreateRouteAmountTypedDict]
    r"""The amount of the route. That amount that will be routed to the specified destination."""
    description: NotRequired[str]
    r"""The description of the route. This description is shown in the reports."""
    destination: NotRequired[PaymentCreateRouteDestinationTypedDict]
    r"""The destination of the route."""


class PaymentCreateRouteRequestBody(BaseModel):
    amount: Optional[PaymentCreateRouteAmount] = None
    r"""The amount of the route. That amount that will be routed to the specified destination."""

    description: Optional[str] = None
    r"""The description of the route. This description is shown in the reports."""

    destination: Optional[PaymentCreateRouteDestination] = None
    r"""The destination of the route."""


class PaymentCreateRouteRequestTypedDict(TypedDict):
    payment_id: str
    r"""Provide the ID of the related payment."""
    request_body: NotRequired[PaymentCreateRouteRequestBodyTypedDict]


class PaymentCreateRouteRequest(BaseModel):
    payment_id: Annotated[
        str,
        pydantic.Field(alias="paymentId"),
        FieldMetadata(path=PathParamMetadata(style="simple", explode=False)),
    ]
    r"""Provide the ID of the related payment."""

    request_body: Annotated[
        Optional[PaymentCreateRouteRequestBody],
        FieldMetadata(request=RequestMetadata(media_type="application/json")),
    ] = None


class PaymentCreateRouteDelayedRoutingDocumentationTypedDict(TypedDict):
    r"""The URL to the generic Mollie API error handling guide."""

    href: NotRequired[str]
    type: NotRequired[str]


class PaymentCreateRouteDelayedRoutingDocumentation(BaseModel):
    r"""The URL to the generic Mollie API error handling guide."""

    href: Optional[str] = "https://docs.mollie.com/errors"

    type: Optional[str] = "text/html"


class PaymentCreateRouteDelayedRoutingLinksTypedDict(TypedDict):
    documentation: NotRequired[PaymentCreateRouteDelayedRoutingDocumentationTypedDict]
    r"""The URL to the generic Mollie API error handling guide."""


class PaymentCreateRouteDelayedRoutingLinks(BaseModel):
    documentation: Optional[PaymentCreateRouteDelayedRoutingDocumentation] = None
    r"""The URL to the generic Mollie API error handling guide."""


class PaymentCreateRouteDelayedRoutingResponseBodyData(BaseModel):
    status: Optional[int] = None
    r"""The status code of the error message. This is always the same code as the status code of the HTTP message itself."""

    title: Optional[str] = None
    r"""The HTTP reason phrase of the error. For example, for a `404` error, the `title` will be `Not Found`."""

    detail: Optional[str] = None
    r"""A detailed human-readable description of the error that occurred."""

    field: OptionalNullable[str] = UNSET
    r"""If the error was caused by a value provided by you in a specific field, the `field` property will contain the name of the field that caused the issue."""

    links: Annotated[
        Optional[PaymentCreateRouteDelayedRoutingLinks], pydantic.Field(alias="_links")
    ] = None


class PaymentCreateRouteDelayedRoutingResponseBody(Exception):
    r"""An error response object."""

    data: PaymentCreateRouteDelayedRoutingResponseBodyData

    def __init__(self, data: PaymentCreateRouteDelayedRoutingResponseBodyData):
        self.data = data

    def __str__(self) -> str:
        return utils.marshal_json(
            self.data, PaymentCreateRouteDelayedRoutingResponseBodyData
        )


class PaymentCreateRouteDelayedRoutingAmountTypedDict(TypedDict):
    r"""The amount of the route. That amount that will be routed to the specified destination."""

    currency: str
    r"""A three-character ISO 4217 currency code."""
    value: str
    r"""A string containing an exact monetary amount in the given currency."""


class PaymentCreateRouteDelayedRoutingAmount(BaseModel):
    r"""The amount of the route. That amount that will be routed to the specified destination."""

    currency: str
    r"""A three-character ISO 4217 currency code."""

    value: str
    r"""A string containing an exact monetary amount in the given currency."""


class PaymentCreateRouteDelayedRoutingDestinationTypedDict(TypedDict):
    r"""The destination of the route."""

    type: NotRequired[str]
    r"""The type of destination. Currently only the destination type `organization` is supported.

    Possible values: `organization`
    """
    organization_id: NotRequired[str]
    r"""Required for destination type `organization`. The ID of the connected organization the funds should be routed to."""


class PaymentCreateRouteDelayedRoutingDestination(BaseModel):
    r"""The destination of the route."""

    type: Optional[str] = None
    r"""The type of destination. Currently only the destination type `organization` is supported.

    Possible values: `organization`
    """

    organization_id: Annotated[
        Optional[str], pydantic.Field(alias="organizationId")
    ] = None
    r"""Required for destination type `organization`. The ID of the connected organization the funds should be routed to."""


class PaymentCreateRouteSelfTypedDict(TypedDict):
    r"""In v2 endpoints, URLs are commonly represented as objects with an `href` and `type` field."""

    href: NotRequired[str]
    r"""The actual URL string."""
    type: NotRequired[str]
    r"""The content type of the page or endpoint the URL points to."""


class PaymentCreateRouteSelf(BaseModel):
    r"""In v2 endpoints, URLs are commonly represented as objects with an `href` and `type` field."""

    href: Optional[str] = None
    r"""The actual URL string."""

    type: Optional[str] = None
    r"""The content type of the page or endpoint the URL points to."""


class PaymentCreateRouteDocumentationTypedDict(TypedDict):
    r"""In v2 endpoints, URLs are commonly represented as objects with an `href` and `type` field."""

    href: NotRequired[str]
    r"""The actual URL string."""
    type: NotRequired[str]
    r"""The content type of the page or endpoint the URL points to."""


class PaymentCreateRouteDocumentation(BaseModel):
    r"""In v2 endpoints, URLs are commonly represented as objects with an `href` and `type` field."""

    href: Optional[str] = None
    r"""The actual URL string."""

    type: Optional[str] = None
    r"""The content type of the page or endpoint the URL points to."""


class PaymentCreateRouteLinksTypedDict(TypedDict):
    r"""An object with several relevant URLs. Every URL object will contain an `href` and a `type` field."""

    self_: NotRequired[PaymentCreateRouteSelfTypedDict]
    r"""In v2 endpoints, URLs are commonly represented as objects with an `href` and `type` field."""
    documentation: NotRequired[PaymentCreateRouteDocumentationTypedDict]
    r"""In v2 endpoints, URLs are commonly represented as objects with an `href` and `type` field."""


class PaymentCreateRouteLinks(BaseModel):
    r"""An object with several relevant URLs. Every URL object will contain an `href` and a `type` field."""

    self_: Annotated[Optional[PaymentCreateRouteSelf], pydantic.Field(alias="self")] = (
        None
    )
    r"""In v2 endpoints, URLs are commonly represented as objects with an `href` and `type` field."""

    documentation: Optional[PaymentCreateRouteDocumentation] = None
    r"""In v2 endpoints, URLs are commonly represented as objects with an `href` and `type` field."""


class PaymentCreateRouteResponseBodyTypedDict(TypedDict):
    r"""The route object."""

    resource: NotRequired[str]
    r"""Indicates the response contains a route object. Will always contain the string `route` for this endpoint."""
    id: NotRequired[str]
    r"""The identifier uniquely referring to this route. Mollie assigns this identifier at route creation time. Mollie will always refer to the route by this ID. Example: `crt_dyARQ3JzCgtPDhU2Pbq3J`."""
    payment_id: NotRequired[str]
    r"""The unique identifier of the payment. For example: `tr_5B8cwPMGnU6qLbRvo7qEZo`. The full payment object can be retrieved via the payment URL in the `_links` object."""
    amount: NotRequired[PaymentCreateRouteDelayedRoutingAmountTypedDict]
    r"""The amount of the route. That amount that will be routed to the specified destination."""
    description: NotRequired[str]
    r"""The description of the route. This description is shown in the reports."""
    destination: NotRequired[PaymentCreateRouteDelayedRoutingDestinationTypedDict]
    r"""The destination of the route."""
    links: NotRequired[PaymentCreateRouteLinksTypedDict]
    r"""An object with several relevant URLs. Every URL object will contain an `href` and a `type` field."""


class PaymentCreateRouteResponseBody(BaseModel):
    r"""The route object."""

    resource: Optional[str] = "route"
    r"""Indicates the response contains a route object. Will always contain the string `route` for this endpoint."""

    id: Optional[str] = None
    r"""The identifier uniquely referring to this route. Mollie assigns this identifier at route creation time. Mollie will always refer to the route by this ID. Example: `crt_dyARQ3JzCgtPDhU2Pbq3J`."""

    payment_id: Annotated[Optional[str], pydantic.Field(alias="paymentId")] = None
    r"""The unique identifier of the payment. For example: `tr_5B8cwPMGnU6qLbRvo7qEZo`. The full payment object can be retrieved via the payment URL in the `_links` object."""

    amount: Optional[PaymentCreateRouteDelayedRoutingAmount] = None
    r"""The amount of the route. That amount that will be routed to the specified destination."""

    description: Optional[str] = None
    r"""The description of the route. This description is shown in the reports."""

    destination: Optional[PaymentCreateRouteDelayedRoutingDestination] = None
    r"""The destination of the route."""

    links: Annotated[
        Optional[PaymentCreateRouteLinks], pydantic.Field(alias="_links")
    ] = None
    r"""An object with several relevant URLs. Every URL object will contain an `href` and a `type` field."""
